<!-- This file was generated by pybib2web, version 0.6.dev0: https://gitlab.com/sosy-lab/software/pybib2web/ -->
<input type="checkbox" id="show-compact">
<label for="show-compact">Compact view</label>
<h2 id="publications">Publications about BLASTSoftware Model Checking</h2>
<nav class="publication-navigation">(<a href="../All/index.html">Show all</a> &ndash; <a href="../index.html">Index</a>)</nav>

<a href="../Category/conferences.html"><h3>Articles in conference or workshop proceedings</h3></a>

<ol class="list-publications">

<li class="bibentry" id="FASE10">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>,
    <span class="author"><span class="firstname">Grégory</span> <span class="lastname">Théoduloz</span></span>, and
    <span class="author"><span class="firstname">Damien</span> <span class="lastname">Zufferey</span></span>.</span>
    <span class="publication-title">Shape Refinement through Explicit Heap Analysis.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">D.S.</span> <span class="lastname">Rosenblum</span></span> and
      <span class="editor"><span class="firstname">G.</span> <span class="lastname">Taentzer</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 13th International Conference on
        Fundamental Approaches to Software Engineering (FASE 2010, Paphos, Cyprus, March 22-26)</em>,
      <span class="series">LNCS 6013</span>,
      <span class="pages">pages 263-277</span>,
      <span class="publication-date">  <span class="year">2010</span></span>.
    </span>
    <span class="publisher">Springer-Verlag, Heidelberg.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-642-12029-9_19" data-doi="10.1007/978-3-642-12029-9_19" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-642-12029-9_19</a>
  </span>
  <a class="bibentry-link" href="#FASE10"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/L.html">L</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/T.html">T</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-642-12029-9_19" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2010-FASE.Shape_Refinement_through_Explicit_Heap_Analysis.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        Shape analysis is a promising technique to prove
        program properties about recursive data structures.
        The challenge is to automatically determine the
        data-structure type, and to supply the shape
        analysis with the necessary information about the
        data structure.  We present a stepwise approach to
        the selection of instrumentation predicates for a
        TVLA-based shape analysis, which takes us a step
        closer towards the fully automatic verification of
        data structures.  The approach uses two techniques
        to guide the refinement of shape abstractions:
        (1) during program exploration, an explicit heap
        analysis collects sample instances of the heap
        structures, which are used to identify the data
        structures that are manipulated by the program; and
        (2) during abstraction refinement along an
        infeasible error path, we consider different
        possible heap abstractions and choose the coarsest
        one that eliminates the infeasible path.  We have
        implemented this combined approach for automatic
        shape refinement as an extension of the software
        model checker BLAST.  Example programs from a
        data-structure library that manipulate doubly-linked
        lists and trees were successfully verified by our tool.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{FASE10,
        author = {Dirk Beyer and Thomas A.~Henzinger and  Gr{\&#x27;e}gory Th{\&#x27;e}oduloz and Damien Zufferey},
        title = {Shape Refinement through Explicit Heap Analysis},
        booktitle = {Proceedings of the 13th International Conference on Fundamental Approaches to Software Engineering (FASE~2010, Paphos, Cyprus, March 22-26)},
        editor = {D.S.~Rosenblum and G.~Taentzer},
        pages = {263-277},
        year = {2010},
        series = {LNCS~6013},
        publisher = {Springer-Verlag, Heidelberg},
        isbn = {978-3-642-12028-2},
        doi = {10.1007/978-3-642-12029-9_19},
        sha256 = {60468f681028a3ac427897405ee5c99894c5baa340896454d378d55267be304f},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2010-FASE.Shape_Refinement_through_Explicit_Heap_Analysis.pdf},
        abstract = {Shape analysis is a promising technique to prove program properties about recursive data structures. The challenge is to automatically determine the data-structure type, and to supply the shape analysis with the necessary information about the data structure.  We present a stepwise approach to the selection of instrumentation predicates for a TVLA-based shape analysis, which takes us a step closer towards the fully automatic verification of data structures.  The approach uses two techniques to guide the refinement of shape abstractions: (1) during program exploration, an explicit heap analysis collects sample instances of the heap structures, which are used to identify the data structures that are manipulated by the program; and (2) during abstraction refinement along an infeasible error path, we consider different possible heap abstractions and choose the coarsest one that eliminates the infeasible path.  We have implemented this combined approach for automatic shape refinement as an extension of the software model checker BLAST.  Example programs from a data-structure library that manipulate doubly-linked lists and trees were successfully verified by our tool.},
        keyword = {BLAST,Software Model Checking},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="ASE08">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>, and
    <span class="author"><span class="firstname">Grégory</span> <span class="lastname">Théoduloz</span></span>.</span>
    <span class="publication-title">Program Analysis with Dynamic Precision Adjustment.</span>
    <span class="howpublished">
      In <em class="booktitle">  Proceedings of the 23rd IEEE/ACM International Conference on
        Automated Software Engineering
        (ASE 2008, L'Aquila, September 15-19)</em>,
      <span class="pages">pages 29-38</span>,
      <span class="publication-date">  <span class="year">2008</span></span>.
    </span>
    <span class="publisher">IEEE Computer Society Press, Los Alamitos (CA).</span>
    <a class="doi" href="https://doi.org/10.1109/ASE.2008.13" data-doi="10.1109/ASE.2008.13" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1109/ASE.2008.13</a>
  </span>
  <a class="bibentry-link" href="#ASE08"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/L.html">L</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/T.html">T</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1109/ASE.2008.13" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2008-ASE.Program_Analysis_with_Dynamic_Precision_Adjustment.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2009-04-16_UCB_CPAplus.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        We present and evaluate a framework and tool for
        combining multiple program analyses which allows the
        dynamic (on-line) adjustment of the precision of each
        analysis depending on the accumulated results. For
        example, the explicit tracking of the values of a
        variable may be switched off in favor of a predicate
        abstraction when and where the number of different
        variable values that have been encountered has
        exceeded a specified threshold. The method is
        evaluated on verifying the SSH client/server software
        and shows significant gains compared with predicate
        abstraction-based model checking.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{ASE08,
        author = {Dirk Beyer and Thomas A.~Henzinger and  Gr{\&#x27;e}gory Th{\&#x27;e}oduloz},
        title = {Program Analysis with Dynamic Precision Adjustment},
        booktitle = {Proceedings of the 23rd IEEE/ACM International Conference on Automated Software Engineering (ASE~2008, L&#x27;Aquila, September 15-19)},
        pages = {29-38},
        year = {2008},
        publisher = {IEEE Computer Society Press, Los Alamitos~(CA)},
        isbn = {978-1-4244-2187-9},
        doi = {10.1109/ASE.2008.13},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2008-ASE.Program_Analysis_with_Dynamic_Precision_Adjustment.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2009-04-16_UCB_CPAplus.pdf},
        abstract = {We present and evaluate a framework and tool for combining multiple program analyses which allows the dynamic (on-line) adjustment of the precision of each analysis depending on the accumulated results. For example, the explicit tracking of the values of a variable may be switched off in favor of a predicate abstraction when and where the number of different variable values that have been encountered has exceeded a specified threshold. The method is evaluated on verifying the SSH client/server software and shows significant gains compared with predicate abstraction-based model checking.},
        keyword = {BLAST,Software Model Checking},
        annote = {},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="CAV07a">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>, and
    <span class="author"><span class="firstname">Grégory</span> <span class="lastname">Théoduloz</span></span>.</span>
    <span class="publication-title">Configurable Software Verification:
    Concretizing the Convergence of 
    Model Checking and Program Analysis.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">W.</span> <span class="lastname">Damm</span></span> and
      <span class="editor"><span class="firstname">H.</span> <span class="lastname">Hermanns</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 19th International Conference on
        Computer Aided Verification 
        (CAV 2007, Berlin, July 3-7)</em>,
      <span class="series">LNCS 4590</span>,
      <span class="pages">pages 504-518</span>,
      <span class="publication-date">  <span class="year">2007</span></span>.
    </span>
    <span class="publisher">Springer-Verlag, Heidelberg.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-540-73368-3_51" data-doi="10.1007/978-3-540-73368-3_51" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-540-73368-3_51</a>
  </span>
  <a class="bibentry-link" href="#CAV07a"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/L.html">L</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/T.html">T</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-540-73368-3_51" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2007-CAV.Configurable_Software_Verification.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="presentation-link" href="https://www.sosy-lab.org/research/prs/2007-07-07_CAV07_Configurable-Program-Analysis.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/presentation.gif">Presentation</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        In automatic software verification, we have observed a
        theoretical convergence of model checking and program
        analysis.  In practice, however, model checkers are
        still mostly concerned with precision, e.g., the
        removal of spurious counterexamples; for this purpose
        they build and refine reachability trees.
        Lattice-based program analyzers, on the other hand,
        are primarily concerned with efficiency.  We designed
        an algorithm and built a tool that can be configured
        to perform not only a purely tree-based or a purely
        lattice-based analysis, but offers many intermediate
        settings that have not been evaluated before.  The
        algorithm and tool take one or more abstract
        interpreters, such as a predicate abstraction and a
        shape analysis, and configure their execution and
        interaction using several parameters.  Our experiments
        show that such customization may lead to dramatic
        improvements in the precision-efficiency spectrum.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{CAV07a,
        author = {Dirk Beyer and Thomas A.~Henzinger and  Gr{\&#x27;e}gory Th{\&#x27;e}oduloz},
        title = {Configurable Software Verification: Concretizing the Convergence of  Model Checking and Program Analysis},
        booktitle = {Proceedings of the 19th International Conference on Computer Aided Verification  (CAV~2007, Berlin, July 3-7)},
        editor = {W.~Damm and H.~Hermanns},
        pages = {504-518},
        year = {2007},
        series = {LNCS~4590},
        publisher = {Springer-Verlag, Heidelberg},
        isbn = {978-3-540-73367-6},
        doi = {10.1007/978-3-540-73368-3_51},
        sha256 = {1c5d0f57fdded4d659c5a86984e19307c50d7770442fa908db20430a22e4b276},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2007-CAV.Configurable_Software_Verification.pdf},
        presentation = {https://www.sosy-lab.org/research/prs/2007-07-07_CAV07_Configurable-Program-Analysis.pdf},
        abstract = {In automatic software verification, we have observed a theoretical convergence of model checking and program analysis.  In practice, however, model checkers are still mostly concerned with precision, e.g., the removal of spurious counterexamples; for this purpose they build and refine reachability trees. Lattice-based program analyzers, on the other hand, are primarily concerned with efficiency.  We designed an algorithm and built a tool that can be configured to perform not only a purely tree-based or a purely lattice-based analysis, but offers many intermediate settings that have not been evaluated before.  The algorithm and tool take one or more abstract interpreters, such as a predicate abstraction and a shape analysis, and configure their execution and interaction using several parameters.  Our experiments show that such customization may lead to dramatic improvements in the precision-efficiency spectrum.},
        keyword = {BLAST,Software Model Checking},
        annote = {},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="PLDI07">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>,
    <span class="author"><span class="firstname">Rupak</span> <span class="lastname">Majumdar</span></span>, and
    <span class="author"><span class="firstname">Andrey</span> <span class="lastname">Rybalchenko</span></span>.</span>
    <span class="publication-title">Path Invariants.</span>
    <span class="howpublished">
      In <em class="booktitle">  Proceedings of the 2007 ACM Conference on
        Programming Language Design and Implementation
        (PLDI 2007, San Diego, CA, June 10-13)</em>,
      <span class="pages">pages 300-309</span>,
      <span class="publication-date">  <span class="year">2007</span></span>.
    </span>
    <span class="publisher">ACM Press, New York (NY).</span>
    <a class="doi" href="https://doi.org/10.1145/1250734.1250769" data-doi="10.1145/1250734.1250769" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1145/1250734.1250769</a>
  </span>
  <a class="bibentry-link" href="#PLDI07"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/L.html">L</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/T.html">T</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1145/1250734.1250769" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2007-PLDI.Path_Invariants.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        The success of software verification depends on the
        ability to find a suitable abstraction of a program
        automatically.  We propose a method for automated
        abstraction refinement which overcomes some
        limitations of current predicate discovery schemes.
        In current schemes, the cause of a false alarm is
        identified as an infeasible error path, and the
        abstraction is refined in order to remove that path.
        By contrast, we view the cause of a false alarm -the
        spurious counterexample- as a full-fledged program,
        namely, a fragment of the original program whose
        control-flow graph may contain loops and represent
        unbounded computations.  There are two advantages to
        using such path programs as counterexamples for
        abstraction refinement.  First, we can bring the whole
        machinery of program analysis to bear on path
        programs, which are typically small compared to the
        original program.  Specifically, we use
        constraint-based invariant generation to automatically
        infer invariants of path programs -so-called path
        invariants.  Second, we use path invariants for
        abstraction refinement in order to remove not one
        infeasibility at a time, but at once all (possibly
        infinitely many) infeasible error computations that
        are represented by a path program.  Unlike previous
        predicate discovery schemes, our method handles loops
        without unrolling them; it infers abstractions that
        involve universal quantification and naturally
        incorporates disjunctive reasoning.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{PLDI07,
        author = {Dirk Beyer and Thomas A.~Henzinger and  Rupak Majumdar and Andrey Rybalchenko},
        title = {Path Invariants},
        booktitle = {Proceedings of the 2007 ACM Conference on Programming Language Design and Implementation (PLDI~2007, San Diego, CA, June 10-13)},
        pages = {300-309},
        year = {2007},
        publisher = {ACM Press, New York~(NY)},
        isbn = {978-1-59593-633-2},
        doi = {10.1145/1250734.1250769},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2007-PLDI.Path_Invariants.pdf},
        abstract = {The success of software verification depends on the ability to find a suitable abstraction of a program automatically.  We propose a method for automated abstraction refinement which overcomes some limitations of current predicate discovery schemes. In current schemes, the cause of a false alarm is identified as an infeasible error path, and the abstraction is refined in order to remove that path. By contrast, we view the cause of a false alarm ---the spurious counterexample--- as a full-fledged program, namely, a fragment of the original program whose control-flow graph may contain loops and represent unbounded computations.  There are two advantages to using such path programs as counterexamples for abstraction refinement.  First, we can bring the whole machinery of program analysis to bear on path programs, which are typically small compared to the original program.  Specifically, we use constraint-based invariant generation to automatically infer invariants of path programs ---so-called path invariants.  Second, we use path invariants for abstraction refinement in order to remove not one infeasibility at a time, but at once all (possibly infinitely many) infeasible error computations that are represented by a path program.  Unlike previous predicate discovery schemes, our method handles loops without unrolling them; it infers abstractions that involve universal quantification and naturally incorporates disjunctive reasoning.},
        keyword = {BLAST,Software Model Checking},
        annote = {Video: &lt;a href=&quot;https://www.youtube.com/watch?v=vUN0n23zVuw&quot;&gt; https://www.youtube.com/watch?v=vUN0n23zVuw&lt;/a&gt;&lt;BR&gt;},
        }
        
      </div>
    </details>
    <details open class="annote">
      <summary>Additional Infos</summary>
      <div>
        
        Video:
        <a href="https://www.youtube.com/watch?v=vUN0n23zVuw">
        https://www.youtube.com/watch?v=vUN0n23zVuw</a><BR>
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="VMCAI07">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>,
    <span class="author"><span class="firstname">Rupak</span> <span class="lastname">Majumdar</span></span>, and
    <span class="author"><span class="firstname">Andrey</span> <span class="lastname">Rybalchenko</span></span>.</span>
    <span class="publication-title">Invariant Synthesis for Combined Theories.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">B.</span> <span class="lastname">Cook</span></span> and
      <span class="editor"><span class="firstname">A.</span> <span class="lastname">Podelski</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the Eighth International Conference on
        Verification, Model Checking, and Abstract Interpretation
        (VMCAI 2007, Nice, January 14-16)</em>,
      <span class="series">LNCS 4349</span>,
      <span class="pages">pages 378-394</span>,
      <span class="publication-date">  <span class="year">2007</span></span>.
    </span>
    <span class="publisher">Springer-Verlag, Heidelberg.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-540-69738-1_27" data-doi="10.1007/978-3-540-69738-1_27" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-540-69738-1_27</a>
  </span>
  <a class="bibentry-link" href="#VMCAI07"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/L.html">L</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/T.html">T</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-540-69738-1_27" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2007-VMCAI.Invariant_Synthesis_for_Combined_Theories.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        We present a constraint-based algorithm for the
        synthesis of invariants expressed in the combined
        theory of linear arithmetic and uninterpreted function
        symbols.  Given a set of programmer-specified
        invariant templates, our algorithm reduces the
        invariant synthesis problem to a sequence of
        arithmetic constraint satisfaction queries.  Since the
        combination of linear arithmetic and uninterpreted
        functions is a widely applied predicate domain for
        program verification, our algorithm provides a
        powerful tool to statically and automatically reason
        about program correctness.  The algorithm can also be
        used for the synthesis of invariants over arrays and
        set data structures, because satisfiability questions
        for the theories of sets and arrays can be reduced to
        the theory of linear arithmetic with uninterpreted
        functions.  We have implemented our algorithm and used
        it to find invariants for a low-level memory allocator
        written in C.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{VMCAI07,
        author = {Dirk Beyer and Thomas A.~Henzinger and  Rupak Majumdar and Andrey Rybalchenko},
        title = {Invariant Synthesis for Combined Theories},
        booktitle = {Proceedings of the Eighth International Conference on Verification, Model Checking, and Abstract Interpretation (VMCAI~2007, Nice, January 14-16)},
        editor = {B.~Cook and A.~Podelski},
        pages = {378-394},
        year = {2007},
        series = {LNCS~4349},
        publisher = {Springer-Verlag, Heidelberg},
        isbn = {978-3-540-69735-0},
        doi = {10.1007/978-3-540-69738-1_27},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2007-VMCAI.Invariant_Synthesis_for_Combined_Theories.pdf},
        abstract = {We present a constraint-based algorithm for the synthesis of invariants expressed in the combined theory of linear arithmetic and uninterpreted function symbols.  Given a set of programmer-specified invariant templates, our algorithm reduces the invariant synthesis problem to a sequence of arithmetic constraint satisfaction queries.  Since the combination of linear arithmetic and uninterpreted functions is a widely applied predicate domain for program verification, our algorithm provides a powerful tool to statically and automatically reason about program correctness.  The algorithm can also be used for the synthesis of invariants over arrays and set data structures, because satisfiability questions for the theories of sets and arrays can be reduced to the theory of linear arithmetic with uninterpreted functions.  We have implemented our algorithm and used it to find invariants for a low-level memory allocator written in C.},
        keyword = {BLAST,Software Model Checking},
        annote = {},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="CAV06">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>, and
    <span class="author"><span class="firstname">Grégory</span> <span class="lastname">Théoduloz</span></span>.</span>
    <span class="publication-title">Lazy Shape Analysis.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">T.</span> <span class="lastname">Ball</span></span> and
      <span class="editor"><span class="firstname">R.B.</span> <span class="lastname">Jones</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 18th International Conference on
        Computer Aided Verification 
        (CAV 2006, Seattle, WA, August 17-20)</em>,
      <span class="series">LNCS 4144</span>,
      <span class="pages">pages 532-546</span>,
      <span class="publication-date">  <span class="year">2006</span></span>.
    </span>
    <span class="publisher">Springer-Verlag, Heidelberg.</span>
    <a class="doi" href="https://doi.org/10.1007/11817963_48" data-doi="10.1007/11817963_48" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/11817963_48</a>
  </span>
  <a class="bibentry-link" href="#CAV06"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/L.html">L</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/T.html">T</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/11817963_48" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2006-CAV.Lazy_Shape_Analysis.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
      <a class="material-link" href="http://www.sosy-lab.org/~dbeyer/blast_sa/"><img alt="" height="15px" width="15px" src="https://www.sosy-lab.org/research/pub/Icons/www.gif">Supplement</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        Many software model checkers are based on predicate
        abstraction.  If the verification goal depends on
        pointer structures, the approach does not work well,
        because it is difficult to find adequate predicate
        abstractions for the heap.  In contrast, shape
        analysis, which uses graph-based heap abstractions,
        can provide a compact representation of recursive data
        structures.  We integrate shape analysis into the
        software model checker BLAST.  Because shape analysis
        is expensive, we do not apply it globally.  Instead,
        we ensure that, like predicates, shape graphs are
        computed and stored locally, only where necessary for
        proving the verification goal.  To achieve this, we
        extend lazy abstraction refinement, which so far has
        been used only for predicate abstractions, to
        three-valued logical structures.  This approach does
        not only increase the precision of model checking, but
        it also increases the efficiency of shape analysis.
        We implemented the technique by extending BLAST with
        calls to TVLA.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{CAV06,
        author = {Dirk Beyer and Thomas A.~Henzinger and  Gr{\&#x27;e}gory Th{\&#x27;e}oduloz},
        title = {Lazy Shape Analysis},
        booktitle = {Proceedings of the 18th International Conference on Computer Aided Verification  (CAV~2006, Seattle, WA, August 17-20)},
        editor = {T.~Ball and R.B.~Jones},
        pages = {532-546},
        year = {2006},
        series = {LNCS~4144},
        publisher = {Springer-Verlag, Heidelberg},
        isbn = {3-540-37406-X},
        doi = {10.1007/11817963_48},
        sha256 = {83aadf3fff8dfe5462691e635eb3f21fda3bd09638cf78a94d71ca87efbd5390},
        url = {http://www.sosy-lab.org/~dbeyer/blast_sa/},
        pdf = {https://www.sosy-lab.org/research/pub/2006-CAV.Lazy_Shape_Analysis.pdf},
        abstract = {Many software model checkers are based on predicate abstraction.  If the verification goal depends on pointer structures, the approach does not work well, because it is difficult to find adequate predicate abstractions for the heap.  In contrast, shape analysis, which uses graph-based heap abstractions, can provide a compact representation of recursive data structures.  We integrate shape analysis into the software model checker BLAST.  Because shape analysis is expensive, we do not apply it globally.  Instead, we ensure that, like predicates, shape graphs are computed and stored locally, only where necessary for proving the verification goal.  To achieve this, we extend lazy abstraction refinement, which so far has been used only for predicate abstractions, to three-valued logical structures.  This approach does not only increase the precision of model checking, but it also increases the efficiency of shape analysis. We implemented the technique by extending BLAST with calls to TVLA.},
        keyword = {BLAST,Software Model Checking},
        annote = {An extended version of this paper appeared in  Proc. Dagstuhl Seminar 06081, IBFI Schloss Dagstuhl, 2006: &lt;BR&gt; &lt;a href=&quot;http://drops.dagstuhl.de/portals/06081/&quot;&gt; http://drops.dagstuhl.de/portals/06081/&lt;/a&gt; &lt;BR&gt; Supplementary material:  &lt;a href=&quot;http://www.sosy-lab.org/~dbeyer/blast_sa/&quot;&gt; http://www.sosy-lab.org/~dbeyer/blast_sa/&lt;/a&gt;},
        }
        
      </div>
    </details>
    <details open class="annote">
      <summary>Additional Infos</summary>
      <div>
        
        An extended version of this paper appeared in 
        Proc. Dagstuhl Seminar 06081, IBFI Schloss Dagstuhl, 2006: <BR>
        <a href="http://drops.dagstuhl.de/portals/06081/">
        http://drops.dagstuhl.de/portals/06081/</a> <BR>
        Supplementary material: 
        <a href="http://www.sosy-lab.org/~dbeyer/blast_sa/">
        http://www.sosy-lab.org/~dbeyer/blast_sa/</a>
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="FASE05">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>,
    <span class="author"><span class="firstname">Ranjit</span> <span class="lastname">Jhala</span></span>, and
    <span class="author"><span class="firstname">Rupak</span> <span class="lastname">Majumdar</span></span>.</span>
    <span class="publication-title">Checking Memory Safety with Blast.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">M.</span> <span class="lastname">Cerioli</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the Eighth International Conference on
        Fundamental Approaches to Software Engineering (FASE 2005, Edinburgh, April 2-10)</em>,
      <span class="series">LNCS 3442</span>,
      <span class="pages">pages 2-18</span>,
      <span class="publication-date">  <span class="year">2005</span></span>.
    </span>
    <span class="publisher">Springer-Verlag, Heidelberg.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-540-31984-9_2" data-doi="10.1007/978-3-540-31984-9_2" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-540-31984-9_2</a>
  </span>
  <a class="bibentry-link" href="#FASE05"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/L.html">L</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/T.html">T</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-540-31984-9_2" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2005-FASE.Checking_Memory_Safety_with_Blast.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        BLAST is an automatic verification tool for checking
        temporal safety properties of C programs.  Given a C
        program and a temporal safety property, BLAST
        statically proves that either the program satisfies
        the safety property or the program has an execution
        trace that exhibits a violation of the property.
        BLAST constructs, explores, and refines abstractions
        of the program state space based on lazy predicate
        abstraction and interpolation-based predicate
        discovery.  We show how BLAST can be used to
        statically prove memory safety for C programs.  We
        take a two-step approach.  First, we use CCured, a
        type-based memory safety analyzer, to annotate with
        run-time checks all program points that cannot be
        proved memory safe by the type system.  Second, we use
        BLAST to remove as many of the run-time checks as
        possible (by proving that these checks never fail),
        and to generate for the remaining run-time checks
        execution traces that witness them fail.  Our
        experience shows that BLAST can remove many of the
        run-time checks added by CCured and provide useful
        information to the programmer about many of the
        remaining checks.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{FASE05,
        author = {Dirk Beyer and Thomas A. Henzinger and Ranjit Jhala and Rupak Majumdar},
        title = {Checking Memory Safety with {{\sc Blast}}},
        booktitle = {Proceedings of the Eighth International Conference on Fundamental Approaches to Software Engineering (FASE~2005, Edinburgh, April 2-10)},
        editor = {M.~Cerioli},
        pages = {2-18},
        year = {2005},
        series = {LNCS~3442},
        publisher = {Springer-Verlag, Heidelberg},
        isbn = {3-540-25420-X},
        doi = {10.1007/978-3-540-31984-9_2},
        sha256 = {8216a41d893b4e987c3a19b82a0c8be06aa7f5bc9b35ef26ab226b95aea241b3},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2005-FASE.Checking_Memory_Safety_with_Blast.pdf},
        abstract = {BLAST is an automatic verification tool for checking temporal safety properties of C programs.  Given a C program and a temporal safety property, BLAST statically proves that either the program satisfies the safety property or the program has an execution trace that exhibits a violation of the property. BLAST constructs, explores, and refines abstractions of the program state space based on lazy predicate abstraction and interpolation-based predicate discovery.  We show how BLAST can be used to statically prove memory safety for C programs.  We take a two-step approach.  First, we use CCured, a type-based memory safety analyzer, to annotate with run-time checks all program points that cannot be proved memory safe by the type system.  Second, we use BLAST to remove as many of the run-time checks as possible (by proving that these checks never fail), and to generate for the remaining run-time checks execution traces that witness them fail.  Our experience shows that BLAST can remove many of the run-time checks added by CCured and provide useful information to the programmer about many of the remaining checks.},
        keyword = {BLAST,Software Model Checking},
        annote = {},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="SAS04">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Adam J.</span> <span class="lastname">Chlipala</span></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>,
    <span class="author"><span class="firstname">Ranjit</span> <span class="lastname">Jhala</span></span>, and
    <span class="author"><span class="firstname">Rupak</span> <span class="lastname">Majumdar</span></span>.</span>
    <span class="publication-title">The Blast Query Language for Software Verification.</span>
    <span class="howpublished">
      In <span class="editor-list"><span class="editor"><span class="firstname">R.</span> <span class="lastname">Giacobazzi</span></span>, editors</span>,
      <em class="booktitle">  Proceedings of the 11th International
        Static Analysis Symposium (SAS 2004, Verona, August 26-28)</em>,
      <span class="series">LNCS 3148</span>,
      <span class="pages">pages 2-18</span>,
      <span class="publication-date">  <span class="year">2004</span></span>.
    </span>
    <span class="publisher">Springer-Verlag, Heidelberg.</span>
    <a class="doi" href="https://doi.org/10.1007/978-3-540-27864-1_2" data-doi="10.1007/978-3-540-27864-1_2" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1007/978-3-540-27864-1_2</a>
  </span>
  <a class="bibentry-link" href="#SAS04"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/L.html">L</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/T.html">T</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1007/978-3-540-27864-1_2" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2004-SAS.The_Blast_Query_Language_for_Software_Verification.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        BLAST is an automatic verification tool for checking
        temporal safety properties of C programs. BLAST is
        based on lazy predicate abstraction driven by
        interpolation-based predicate discovery. In this
        paper, we present the BLAST specification
        language. The language specifies program properties at
        two levels of precision. At the lower level, monitor
        automata are used to specify temporal safety
        properties of program executions (traces). At the
        higher level, relational reachability queries over
        program locations are used to combine lower-level
        trace properties. The two-level specification language
        can be used to break down a verification task into
        several independent calls of the model-checking
        engine. In this way, each call to the model checker
        may have to analyze only part of the program, or part
        of the specification, and may thus succeed in a
        reduction of the number of predicates needed for the
        analysis. In addition, the two-level specification
        language provides a means for structuring and
        maintaining specifications.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{SAS04,
        author = {Dirk Beyer and Adam J. Chlipala and Thomas A. Henzinger and Ranjit Jhala and Rupak Majumdar},
        title = {The {{\sc Blast}} Query Language for Software Verification},
        booktitle = {Proceedings of the 11th International Static Analysis Symposium (SAS~2004, Verona, August 26-28)},
        editor = {R.~Giacobazzi},
        pages = {2-18},
        year = {2004},
        series = {LNCS~3148},
        publisher = {Springer-Verlag, Heidelberg},
        isbn = {3-540-22791-1},
        doi = {10.1007/978-3-540-27864-1_2},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2004-SAS.The_Blast_Query_Language_for_Software_Verification.pdf},
        abstract = {BLAST is an automatic verification tool for checking temporal safety properties of C programs. BLAST is based on lazy predicate abstraction driven by interpolation-based predicate discovery. In this paper, we present the BLAST specification language. The language specifies program properties at two levels of precision. At the lower level, monitor automata are used to specify temporal safety properties of program executions (traces). At the higher level, relational reachability queries over program locations are used to combine lower-level trace properties. The two-level specification language can be used to break down a verification task into several independent calls of the model-checking engine. In this way, each call to the model checker may have to analyze only part of the program, or part of the specification, and may thus succeed in a reduction of the number of predicates needed for the analysis. In addition, the two-level specification language provides a means for structuring and maintaining specifications.},
        keyword = {BLAST,Software Model Checking},
        annote = {},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="IWPC04">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>,
    <span class="author"><span class="firstname">Ranjit</span> <span class="lastname">Jhala</span></span>, and
    <span class="author"><span class="firstname">Rupak</span> <span class="lastname">Majumdar</span></span>.</span>
    <span class="publication-title">An Eclipse Plug-in for Model Checking.</span>
    <span class="howpublished">
      In <em class="booktitle">  Proceedings of the 12th IEEE International Workshop on
        Program Comprehension (IWPC 2004, Bari, June 24-26)</em>,
      <span class="pages">pages 251-255</span>,
      <span class="publication-date">  <span class="year">2004</span></span>.
    </span>
    <span class="publisher">IEEE Computer Society Press, Los Alamitos (CA).</span>
    <a class="doi" href="https://doi.org/10.1109/WPC.2004.1311069" data-doi="10.1109/WPC.2004.1311069" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1109/WPC.2004.1311069</a>
  </span>
  <a class="bibentry-link" href="#IWPC04"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/L.html">L</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/T.html">T</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1109/WPC.2004.1311069" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2004-IWPC.An_Eclipse_Plug-in_for_Model_Checking.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        While model checking has been successful in uncovering
        subtle bugs in code, its adoption in software
        engineering practice has been hampered by the absence
        of a simple interface to the programmer in an
        integrated development environment. We describe an
        integration of the software model checker BLAST into
        the Eclipse development environment. We provide a
        verification interface for practical solutions for
        some typical program analysis problems -assertion
        checking, reachability analysis, dead code analysis,
        and test generation- directly on the source code. The
        analysis is completely automatic, and assumes no
        knowledge of model checking or formal
        notation. Moreover, the interface supports incremental
        program verification to support incremental design and
        evolution of code.
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{IWPC04,
        author = {Dirk Beyer and Thomas A. Henzinger and Ranjit Jhala and Rupak Majumdar},
        title = {An {Eclipse} Plug-in for Model Checking},
        booktitle = {Proceedings of the 12th IEEE International Workshop on Program Comprehension (IWPC~2004, Bari, June 24-26)},
        pages = {251-255},
        year = {2004},
        publisher = {IEEE Computer Society Press, Los Alamitos~(CA)},
        isbn = {0-7695-2149-5},
        doi = {10.1109/WPC.2004.1311069},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2004-IWPC.An_Eclipse_Plug-in_for_Model_Checking.pdf},
        abstract = {While model checking has been successful in uncovering subtle bugs in code, its adoption in software engineering practice has been hampered by the absence of a simple interface to the programmer in an integrated development environment. We describe an integration of the software model checker BLAST into the Eclipse development environment. We provide a verification interface for practical solutions for some typical program analysis problems --assertion checking, reachability analysis, dead code analysis, and test generation-- directly on the source code. The analysis is completely automatic, and assumes no knowledge of model checking or formal notation. Moreover, the interface supports incremental program verification to support incremental design and evolution of code.},
        keyword = {BLAST,Software Model Checking},
        annote = {},
        }
        
      </div>
    </details>
  </span>
</li>

<li class="bibentry" id="ICSE04">
  <span class="main-info">
    <span class="author-list"><span class="author"><a href="../Author/BEYER-D.html"><span class="firstname">Dirk</span> <span class="lastname">Beyer</span></a></span>,
    <span class="author"><span class="firstname">Adam J.</span> <span class="lastname">Chlipala</span></span>,
    <span class="author"><span class="firstname">Thomas A.</span> <span class="lastname">Henzinger</span></span>,
    <span class="author"><span class="firstname">Ranjit</span> <span class="lastname">Jhala</span></span>, and
    <span class="author"><span class="firstname">Rupak</span> <span class="lastname">Majumdar</span></span>.</span>
    <span class="publication-title">Generating Tests from Counterexamples.</span>
    <span class="howpublished">
      In <em class="booktitle">  Proceedings of the 26th IEEE International Conference on
        Software Engineering (ICSE 2004, Edinburgh, May 26-28)</em>,
      <span class="pages">pages 326-335</span>,
      <span class="publication-date">  <span class="year">2004</span></span>.
    </span>
    <span class="publisher">IEEE Computer Society Press, Los Alamitos (CA).</span>
    <a class="doi" href="https://doi.org/10.1109/ICSE.2004.1317455" data-doi="10.1109/ICSE.2004.1317455" title="The digital object identifier permanently identifies a digital article or document.">doi:10.1109/ICSE.2004.1317455</a>
  </span>
  <a class="bibentry-link" href="#ICSE04"><img height="12px" width="12px" src="https://www.sosy-lab.org/images/transparent.gif" alt="Link to this entry"></a>
  <span class="additional-info">
    <span class="inline-info">
      <span class="keyword-list">Keyword(s):
        <a class="keyword" href="../Keyword/B.html">B</a>,
        <a class="keyword" href="../Keyword/L.html">L</a>,
        <a class="keyword" href="../Keyword/A.html">A</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/T.html">T</a>,
        <a class="keyword" href="../Keyword/S.html">S</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/F.html">f</a>,
        <a class="keyword" href="../Keyword/T.html">t</a>,
        <a class="keyword" href="../Keyword/W.html">w</a>,
        <a class="keyword" href="../Keyword/A.html">a</a>,
        <a class="keyword" href="../Keyword/R.html">r</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/M.html">M</a>,
        <a class="keyword" href="../Keyword/O.html">o</a>,
        <a class="keyword" href="../Keyword/D.html">d</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/L.html">l</a>,
        <a class="keyword" href="../Keyword/-.html"> </a>,
        <a class="keyword" href="../Keyword/C.html">C</a>,
        <a class="keyword" href="../Keyword/H.html">h</a>,
        <a class="keyword" href="../Keyword/E.html">e</a>,
        <a class="keyword" href="../Keyword/C.html">c</a>,
        <a class="keyword" href="../Keyword/K.html">k</a>,
        <a class="keyword" href="../Keyword/I.html">i</a>,
        <a class="keyword" href="../Keyword/N.html">n</a>,
        <a class="keyword" href="../Keyword/G.html">g</a>
      </span>
    </span>
    <span class="link-list">
      <a class="publishers-version-link doi-link" href="https://doi.org/10.1109/ICSE.2004.1317455" title="Link to official version of paper (may be a landing page with more information)"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/doi.svg">Publisher's Version</a>
      <a class="pdf-link" href="https://www.sosy-lab.org/research/pub/2004-ICSE.Generating_Tests_from_Counterexamples.pdf"><img alt="" height="17px" width="17px" src="https://www.sosy-lab.org/research/pub/Icons/pdf.gif">PDF</a>
    </span>
    <details  class="abstract">
      <summary>Abstract</summary>
      <div>
        We have extended the software model checker BLAST to
        automatically generate test suites that guarantee full
        coverage with respect to a given predicate. More
        precisely, given a C program and a target predicate p,
        BLAST determines the set L of program locations which
        program execution can reach with p true, and
        automatically generates a set of test vectors that
        exhibit the truth of p at all locations in L. We have
        used BLAST to generate test suites and to detect dead
        code in C programs with up to 30K lines of code. The
        analysis and test-vector generation is fully automatic
        (no user intervention) and exact (no false positives).
      </div>
    </details>
    <details  class="bibtex">
      <summary>BibTeX Entry</summary>
      <div>
        @inproceedings{ICSE04,
        author = {Dirk Beyer and Adam J. Chlipala and Thomas A. Henzinger and Ranjit Jhala and Rupak Majumdar},
        title = {Generating Tests from Counterexamples},
        booktitle = {Proceedings of the 26th IEEE International Conference on Software Engineering (ICSE~2004, Edinburgh, May 26-28)},
        pages = {326-335},
        year = {2004},
        publisher = {IEEE Computer Society Press, Los Alamitos~(CA)},
        isbn = {0-7695-2163-0},
        doi = {10.1109/ICSE.2004.1317455},
        url = {},
        pdf = {https://www.sosy-lab.org/research/pub/2004-ICSE.Generating_Tests_from_Counterexamples.pdf},
        abstract = {We have extended the software model checker BLAST to automatically generate test suites that guarantee full coverage with respect to a given predicate. More precisely, given a C program and a target predicate p, BLAST determines the set L of program locations which program execution can reach with p true, and automatically generates a set of test vectors that exhibit the truth of p at all locations in L. We have used BLAST to generate test suites and to detect dead code in C programs with up to 30K lines of code. The analysis and test-vector generation is fully automatic (no user intervention) and exact (no false positives).},
        keyword = {BLAST,Software Model Checking},
        annote = {},
        }
        
      </div>
    </details>
  </span>
</li>

</ol>
 <section id="disclaimer"> <h4>Disclaimer:</h4> <p class="disclaimer"> This material is presented to ensure timely dissemination of scholarly and technical work. Copyright and all rights therein are retained by authors or by other copyright holders. All person copying this information are expected to adhere to the terms and constraints invoked by each author's copyright. In most cases, these works may not be reposted without the explicit permission of the copyright holder. </p> </section> <footer id="generator">This file was generated by <a href="https://gitlab.com/sosy-lab/software/pybib2web/">pybib2web</a>, version 0.6.dev0</footer>